﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MultipleLevelObject.Xml;

namespace MultipleLevelObject.Pages
{
	/// <summary>
	/// Interaction logic for Page1.xaml
	/// </summary>
	public partial class Page1 : PageBase
	{
		public Page1()
		{
			InitializeComponent();
		}
	}

	public class LeagueStyleSelector : StyleSelector
	{
		public override Style SelectStyle(object item, DependencyObject container)
		{
			if (item is ScenesScene)
				return this.SceneStyle;
			else if (item is ScenesSceneLevel1)
				return this.ItemStyle;
			else if (item is ScenesSceneLevel1Level2)
				return this.Sub1Style;
			else if (item is Level3)
				return this.Sub2Style;
			return this.SceneStyle;
		}

		public Style SceneStyle
		{
			get;
			set;
		}

		public Style ItemStyle
		{
			get;
			set;
		}
		public Style Sub1Style
		{
			get;
			set;
		}

		public Style Sub2Style
		{
			get;
			set;
		}
	}

	public class LeagueDataTemplateSelector : DataTemplateSelector
	{

		private HierarchicalDataTemplate sceneTemplate;
		private HierarchicalDataTemplate itemTemplate;
		private HierarchicalDataTemplate sub1Template;
		private HierarchicalDataTemplate sub2Template;

		public LeagueDataTemplateSelector()
		{
		}

		public override DataTemplate SelectTemplate(object item, DependencyObject container)
		{

			if (item is ScenesScene)
				return this.sceneTemplate;
			else if (item is ScenesSceneLevel1)
				return this.itemTemplate;
			else if (item is ScenesSceneLevel1Level2)
				return this.sub1Template;
			else if (item is Level3)
				return this.sub2Template;
			return this.sceneTemplate;

		}

		public HierarchicalDataTemplate SceneTemplate
		{
			get
			{
				return this.sceneTemplate;
			}
			set
			{
				this.sceneTemplate = value;
			}
		}

		public HierarchicalDataTemplate ItemTemplate
		{
			get
			{
				return this.itemTemplate;
			}
			set
			{
				this.itemTemplate = value;
			}
		}
		public HierarchicalDataTemplate Sub1Template
		{
			get
			{
				return this.sub1Template;
			}
			set
			{
				this.sub1Template = value;
			}
		}

		public HierarchicalDataTemplate Sub2Template
		{
			get
			{
				return this.sub2Template;
			}
			set
			{
				this.sub2Template = value;
			}
		}

	}

	public class TestingXmlData
	{
		private Scenes scene;

		public TestingXmlData()
		{
			this.TestingDataSource = new List<ScenesScene>();

			var t = AppDomain.CurrentDomain.BaseDirectory;
			scene = Scenes.LoadFromFile(t + @"../../Scenes.xml");

			var numberBranch = (from rr in scene.Items select rr).ToList();
			this.TestingDataSource = numberBranch;

		}

		public List<ScenesScene> TestingDataSource
		{
			get;
			set;
		}
	}
}

